<?php

namespace App\Http\Controllers\Admin;

use App\Module;
use Exception;
use App\Country;
use App\City;
use Illuminate\View\View;
use App\CountryDescription;
use App\CityDescription;
use Illuminate\Http\Request;
use Illuminate\Http\JsonResponse;
use Illuminate\Routing\Redirector;
use App\Http\Controllers\Controller;
use App\Http\Requests\CountryRequest;
use Illuminate\Http\RedirectResponse;
use Mcamara\LaravelLocalization\Facades\LaravelLocalization;

class CountryController extends Controller
{

    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/countries';
    /** View folder */
    private $viewDirectory= 'admin.countries.';

    /**
     * Display a listing of the resource.
     *
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('countries.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the pages.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $query = Country::latest()
            ->join('country_descriptions AS ad', 'countries.id', 'ad.country_id')
            ->join('languages', 'languages.id', 'ad.language_id')
            ->where('local', LaravelLocalization::getCurrentLocale())
            ->select(['ad.name', 'countries.*']);

        if ($request->date_from) {
            $query->whereDate('countries.created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('countries.created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('ad.name', 'LIKE', '%'.$request->name.'%');
        }
       

        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $countries= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('countries'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('countries.store');
        $head= __('countries.new');
        return view( $this->viewDirectory.'form', compact('action', 'head') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param CountryRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(CountryRequest $request) :RedirectResponse
    {
        $country = Country::create($request->all());

        
        $this->saveData($request, $country->id);

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }


    /**
     * Show the form for editing the specified resource.
     *
     * @param Country $country
     * @return View
     */
    public function edit(Country $country) :View
    {
        $action= route('countries.update', $country->id);

        $query = CountryDescription::where('country_id', $country->id)
            ->join('languages', 'languages.id', 'country_descriptions.language_id')
            ->select(['country_descriptions.*', 'languages.local']);

        $CountryDescription= $query->get();

        foreach ($CountryDescription as $row) {
            $country[$row->local]= $row;
        }

        return view( $this->viewDirectory.'form', compact('country', 'action') );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param CountryRequest $request
     * @param Country $country
     * @return RedirectResponse|Redirector
     */
    public function update(CountryRequest $request, Country $country) :RedirectResponse
    {

        // Update image and category id if request has it
        $country->update($request->all());

        // update image to youtube api thumbnail if request have not image
       

        // Delete old description
        CountryDescription::where('country_id', $country->id)->delete();


        // Insert new description
        $this->saveData( $request, $country->id );

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Handle Save form data
     *
     * @param CountryRequest $request
     * @param int $country_id
     * @return void
     */

    private function saveData(CountryRequest $request, int $country_id ):void
    {
        $requestData= $request->all();
        foreach (languages() as $lang) {
            $data=[
                'country_id'=> $country_id,
                'language_id'=> $lang->id,
                'name'=> $requestData['name_'.$lang->local],
                
            ];
            CountryDescription::create($data);
        }

        if ($request->has('city')){
        	$city = City::create([
        		'country_id'=>$country_id
        	]);
            foreach ($request->city as $rows) {
                foreach($rows as $row){
                $data=[
                    'name'=> $row['name'],
                    'language_id'=> $row['language_id'],
                    'city_id'=> $city->id,
                ];

                CityDescription::create($data);
}
            }
        }

    }


    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $country = Country::withTrashed()->find($id);
        if ($country) {
            if ($country->deleted_at) {
                $country->forceDelete();
            } else {
                $country->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            Country::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            Country::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $country = Country::withTrashed()->find($id);

        if ($country){
            $country->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $country = Country::whereIn('id', $request->ids)->onlyTrashed();
        if ($country){
            $country->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
